%Fourier representation of signals
%MATLAB tutorial series (Part 1.1)

%% Example 1.1: use of fft and ifft   

% signal
x=[1 1 1 0 0 0 0 0 1 1]
% plot signal
figure(1)
stem(x,'LineWidth',2.5)
title('x')
% N
N=length(x);
% ck
c=fft(x)/N
% 
x1=ifft(c)*N

% plot x1
figure(2)
stem(x1,'LineWidth',2.5)
title('ifft(c)*N')


%% Example 1.2: use of freqz    

% % signal
% x=[1 1 1 1 1 1 1 1 1 1 1];
% % define omega
% om=linspace(-pi,pi,500);
% % Compute DTFT
% X=freqz(x,1,om);
% % |X|
% X1=abs(X);
% % plot  magnitude spectrum 
% figure(1)
% plot(om,X1,'LineWidth',2.5)
% xlabel('Normalized angular frequency  \omega   (rad x cycles/sample)')
% ylabel('Magnitude |X|')
% % phase
% p=angle(X);
% % plot  magnitude spectrum 
% figure(2)
% plot(om,p,'LineWidth',2.5)
% xlabel('Normalized angular frequency  \omega   (rad x cycles/sample)')
% ylabel('Phase (rad)')


%% Example 1.3: use of freqz 

% % time t or n
% t=-200:1:200;
% % signal
% x=0.6*sinc(0.6*t);
% % plots signal
% figure(1)
% plot(t,x,'LineWidth',2.5)
% title('x')
% % define omega
% om=linspace(-pi,pi,500);
% % compute DTFT
% X=freqz(x,1,om);
% % plot magnitude spectrum
% figure(2)
% plot(om,abs(X),'LineWidth',2.5)
% % scale it with pi
% figure(3)
% plot(om/pi,abs(X),'LineWidth',2.5)


%% Example 1.4: use of freqz 

% % time t or n
% t=-200:0.1:200;
% % signal
% x=0.6*sinc(0.6*t);
% % plots signal
% figure(1)
% plot(t,x,'LineWidth',2.5)
% title('x')
% % define omega
% om=linspace(-pi,pi,500);
% % compute DTFT
% X=(1/10)*freqz(x,1,om);
% % plot magnitude spectrum
% figure(2)
% plot(om,abs(X),'LineWidth',2.5)
% % scale it with pi
% figure(3)
% plot(om*10/pi,abs(X),'LineWidth',2.5)

%% Example 1.5: frequency response    

% % zeros
% zer = [-1 1];
% % ploes
% pol=0.9*exp(1i*pi*1/4*[-1 +1]);
% % Turn it to rational transfer function
% [b,a]=zp2tf(zer',pol',1);
% % omega
% om=linspace(-pi,pi,500);
% % freq. response
% X=freqz(b,a,om);
% % magnitude response scaled by pi
% figure(1)
% plot(om/pi,abs(X),'LineWidth',2.5)
% xlabel('Normalized frequency (\pi x rad/sample) ')
% 






